public class Fraction {
    private static int ggt(int x, int y) {
	while (y != 0) {
	    int tmp = x % y;
	    x = y;
	    y = tmp;
	}
	return x;
    }

    private int num = 0, denom = 1;
    public Fraction() {
    }
    public Fraction(int num) {
	this.num = num;
    }
    public Fraction(int num, int denom) {
	if (denom == 0)
	    throw new IllegalArgumentException("denom must not be zero");
	if (denom < 0) {
	    num *= -1; denom *= -1;
	}
	if (num != 0) {
	    int g = ggt(Math.abs(num), denom);
	    this.num = num / g;
	    this.denom = denom / g;
	}
    }
    public String toString() {
	return num + "/" + denom;
    }
    public boolean equals(Object o) {
	if (!(o instanceof Fraction))
	    return false;
	Fraction x = (Fraction) o;
	return num == x.num && denom == x.denom;
    }
    public Fraction add(Fraction x) {
	return new Fraction(num * x.denom + x.num * denom, denom * x.denom);
    }
    public double getValue() {
	return (double) num / (double) denom;
    }
}
